clc; clear all; close all;
% vyhladzovaci filter na profilove data
% XXXXXXXXXX

% nacitanie mena suboru
[fname,pname] = uigetfile('*.dat','input of profile data (2 columns ASCII file)');

% nacitanie vstupnych dat zo suboru
inpXF = dlmread(fname,' ');
% stlpce su separovane do matic x a F
x=inpXF(:,1)';  F=inpXF(:,2)';
% je urceny pocet nacitanych profilovych dat
nx = length(x);

% definovanie vah filtra (5 bodovy car-box filter)
car_box_filter = [1/5 1/5 1/5 1/5 1/5];

% samotna filtracia pomocou funkcie conv()
filtered1 = conv(F,car_box_filter);
nx_filtered = length(filtered1);
% uprava dlzky vystupu
for i = 3:nx_filtered-2
  filtered_uprav1 (i-2) = filtered1(i);
end;

% ten isty vypocet, ale v cykle
for i = 3:nx-2
    filtered_uprav2(i) = car_box_filter(1)*F(i-2) + car_box_filter(2)*F(i-1) + car_box_filter(3)*F(i) + car_box_filter(4)*F(i+1) + car_box_filter(5)*F(i+2);
end;
% umela uprava zaciatku a konca filtrovanej matice
filtered_uprav2(1) = F(1); filtered_uprav2(2) = F(2); filtered_uprav2(nx-1) = F(nx-1); filtered_uprav2(nx) = F(nx);
    
% vykreslenie vysledkov
figure, plot(x,F,x,filtered_uprav1);
xlabel('x [m]','FontSize',10); ylabel('nacitane pole [jednotka pola]','FontSize',10); legend('povodne pole','filtrovane pole1');

figure, plot(x,F,x,filtered_uprav2);
xlabel('x [m]','FontSize',10); ylabel('nacitane pole [jednotka pola]','FontSize',10); legend('povodne pole','filtrovane pole2');

figure, plot(x,filtered_uprav1,x,filtered_uprav2);
xlabel('x [m]','FontSize',10); ylabel('nacitane pole [jednotka pola]','FontSize',10); legend('filtrovane pole1','filtrovane pole2');

% zapis vustupu do suboru
% tvorba jednej matice z dvoch jednostlpcovych
outpfield = [x' filtered_uprav1'];
% zapis do ASCII suboru
save  filtered.dat  outpfield  -ascii  -double;
